local M = {}

-- threshold set to 0.05 for whats considered moderate damage
-- to call onCarDamaged function, change it if you like
local heavyDamageThreshold = 0.05

local hasInit = false
local isDamaged = false

local function onCarDamaged()
	-- code executed when car is damaged 
	print(obj:getID() .. " car damaged!")
end

local function damageUpdateCallback(damageData, damageDataDelta)
	-- if player in vehicle or already was moderately damaged before, stop
	if playerInfo.firstPlayerSeated or isDamaged then return end

	local totalDamage = 0
	
	for k, v in pairs(damageDataDelta.body) do
		totalDamage = totalDamage + v
	end
	
	if totalDamage >= heavyDamageThreshold then
		onCarDamaged()
	
		isDamaged = true
	end
end

local function updateGFX(dt)
	if not hasInit then
		if damageTracker then
			-- register callback function to get car damage events
			damageTracker.registerDamageUpdateCallback(damageUpdateCallback)
			hasInit = true
		end
	end
	
	-- main.lua only calls updateGFX if player in vehicle
	if not playerInfo.firstPlayerSeated then
		damageTracker.updateGFX(dt)
	end
end

M.updateGFX = updateGFX

return M